(*
 *  beware IRC services, accountUSINGbot.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)
unit accountUSINGbot;

interface
uses
  buser    , bstuff , objbot , boptiontable , accountcore , pgstuff , pgtypes ,
  bchannel ;

type
  taccountUSINGbot=class;
  tcmdproc=procedure(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
  textrareplaceproc=procedure(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;var info,syntax:string);

  tcmdtab=record
    cmd:string;
    customcmd:string;
    level:integer;
    p:tcmdproc;
    enabled:boolean;
    minparams: integer;
    //note this is matched against parc which includes the name of the parameter
    //e.g. login example example parc=3
    info:string;
    syntax:string;
    extrareplaceproc:textrareplaceproc;
  end;
  acmdtab = array[word] of tcmdtab; // the size of the refernce in here is a dummy and shouldn't actually matter
  pcmdtab = ^acmdtab;
  acmdlookup = array[word] of word;
  pcmdlookup = ^acmdlookup;
  taccountUSINGbot=class(tobjbot)
  public
    botmaxcmd      : integer      ;
    cmdtab         : pcmdtab      ;
    cmdsorted      : pcmdlookup   ;
    maxoptiontable : integer      ;
    optiontable    : poptiontable ;
    //accountcore    : taccountcore ;
    aubopt         : record
      nick:string;
      userid:string;
      bothost:string;
      info:string;
      //operchannel:string;
      operlevel:integer;
      accountlen:integer;
      //accountchars:string;
      botmodes:string;
    end;
    nickatservervar:boolean;
    //autosavenextts:integer;
    //up:boolean;   {the service unit is enabled}

    //srvunit:tserviceunit;
    //currentoperchannel:string;
    sendtalk:string;
    prefix:string;  {the ":sender " part of a message sent by this bot}

    mybot:tuser;  {this unit has one bot, pointer to tuser for bot}
    validaccounttable:array[0..1,0..255] of boolean;
    commandsfile:string;
    configfile:string;
    cfgtag:string;
    //accountsfile='auth.accounts.ini';
    emailbanfile:string;

    botlogfile:string;
    cmd:string; {currently called cmd}
    constructor create;
    destructor destroy;override;
    procedure buildoptiontable;virtual;
    procedure setupsrvunit;override;
    function haslevel(us:tuser):integer;
    procedure botinit;virtual;
    procedure savecmd;
    procedure loadcmd;
    procedure logaction(sptr:tuser;s:string);
    procedure botsave(saveall: boolean);virtual;
    procedure localtimehandler;virtual;
    function validaccountname(const s:string):boolean;
    procedure updatevalidaccounttable;
    function error_nosuchaccount(const name:string):string;
    function error_nosuchchannel(const name:string):string;
    function error_nosuchnick(const name:string):string;
    function localloginchecks(sptr:tuser;parc:integer;parv:pparams;const msg:string):boolean;virtual;
    function getloginname(us:tuser):string;
    function candeopk:boolean; virtual;
    function ismortal(us:tuser):boolean;virtual;
    function denyaccess(us:tuser):boolean;virtual;
    procedure localshutdown;virtual;
    function getaccountcore : taccountcore ;virtual;
    procedure sendversionreply ; virtual;
    procedure loadaccountdependent; virtual;
    function hasvoice(us:tuser;ch:tchannel):integer;virtual;
    function hasop(us:tuser;ch:tchannel):integer;virtual;
    function hasmaster(us:tuser;ch:tchannel):integer;virtual;
    procedure buildsorted;

    function isregisteredchan(channel:string):boolean;virtual;
    //stub always returns false override in descendent classes

    procedure donewconfigchanges;virtual;
    //stub
  end;



function replacespecial(const invalue,nick,servername,cmd,newline: string) : string;


//procedure onsendburst(tag:taddrint);
//procedure ondisconnect(tag:taddrint);
procedure onstartup(tag:taddrint);
procedure onshutdown(tag:taddrint);
//procedure ontimer(tag:taddrint);
//procedure onaccount(sptr:tuser;us:tuser;tag:taddrint);
//procedure ondestroyuser(us:tuser;tag:taddrint);
//procedure onrehash(tag:taddrint);

implementation
uses
  bconsts      , bparse    , btime  , bconfig    , bservicemngr , bcmds       ,
  unitwritetxt , bservunit , bcrash , pgdebugout , binipstuff   , unitbanmask ,
  sysutils     ;

procedure onoperchannelchange(oldvalue:string;tag:taddrint);
var
  oldvaluech : tchannel;
begin
  with taccountUSINGbot(tag) do begin
    if assigned(mybot) then begin
      oldvaluech := findchan(oldvalue);
      if assigned(oldvaluech) then begin
        if (not isregisteredchan(oldvalue)) and isonchannel(mybot,oldvaluech) then begin
          sendparse(mybot.idstr+' '+tok_part+' '+oldvalue);
        end;
      end;
      bot_join(mybot,opt.operchannel,'+ntsio',mybot.idstr,globaldefaultts);
    end;
  end;
end;



function replacespecial(const invalue,nick,servername,cmd,newline: string) : string;
begin
  result := replacealias(invalue,'%nick%',nick);
  result := replacealias(result,'%server%',servername);
  result := replacealias(result,'%cmd%',cmd);
  result := replacealias(result,'%newline%',newline);

  {result := '';
  for counter := 1 to length(invalue) do begin
    case invalue[counter] of
      '~' : begin
        result := result + nick;
      end;
      '^' : begin
        result := result + servername;
      end;
      '' : begin
        result := result + cmd;
      end;
      '|' : begin
        result := result + newline;
      end;

      else begin
        result := result + invalue[counter];
      end;
    end;

  end;}
end;

constructor taccountUSINGbot.create;
begin
  inherited create;
  maxoptiontable := -1;
  buildoptiontable;
end;

destructor taccountUSINGbot.destroy;
begin
  if assigned(optiontable) then freemem(optiontable);
  inherited destroy;
end;

procedure taccountUSINGbot.buildoptiontable;
var
  startat : integer;
begin
  startat := maxoptiontable+1;
  inc(maxoptiontable,7);
  getmem(optiontable,sizeof(Toptionentry)*(maxoptiontable+1));
  fillchar(optiontable^,sizeof(Toptionentry)*(maxoptiontable+1),0);
  with optiontable[startat] do begin
    p     := @aubopt.nick;
    typ   := opt_str;
    name  := 'nick';
    info  := 'bot''s nick';
    def_s := '';
  end;
  with optiontable[startat+1] do begin
    p    := @aubopt.userid;
    typ  := opt_str;
    name := 'userid';
    info := 'bot''s userid (empty for global userid setting)';
    def_s:= '';
  end;
  with optiontable[startat+2] do begin
    p:=@aubopt.info;
    typ:=opt_str;
    name:='info';
    info:='bot''s realname';
    def_s:='';
  end;

  {with optiontable[startat+3] do begin
    p:=@aubopt.operchannel;
    typ:=opt_str;
    name:='operchannel';
    info:='event log channel';
    def_s:='#Admin';
  end;}
  with optiontable[startat+3] do begin
    p:=@aubopt.operlevel;
    typ:=opt_int;
    name:='OperLevel';
    info:='access level for opers who are not logged in';
    def_i:=maxlevel div 10;
  end;
  with optiontable[startat+4] do begin
    p:=@aubopt.accountlen;
    typ:=opt_int;
    name:='AccountLen';
    info:='maximum length of account name.';
    def_i:=12;
  end;
  {with optiontable[startat+5] do begin
    p:=@aubopt.accountchars;
    typ:=opt_str;
    name:='AccountChars';
    info:='allowed characters in account name, for first char, for other chars. A means A-Z, etc';
    def_s:='Aa0 Aa0';
  end;}
  with optiontable[startat+5] do begin
    p:=@aubopt.botmodes;
    typ:=opt_str;
    name:='BotModes';
    info:='modes set on the client';
    def_s:='dk';
  end;
  with optiontable[startat+6] do begin
    p:=@aubopt.bothost;
    typ:=opt_str;
    name:='BotHost';
    info:='the client''s host';
    def_s:='';
  end;
end;

procedure onprivmsg(nickatserver:boolean;sptr:tuser;target:tuser;s:string;tag:taddrint);
const errormsg='This command is either unknown, or you have no access to it.';
var
  parv:tparams;
  parc:integer;
  a,b:integer;
  bool:boolean;
  infolocal:string;
  syntaxlocal:string;
begin
 with taccountUSINGbot(tag) do begin
  nickatservervar := nickatserver;
  parc := strtok(s,' ',@parv);
  cmd := ircupper(parv[0]);
  if cmd = '' then exit;
  sendtalk := sendtalkstr(mybot,sptr);
  b := -1;
  bool := denyaccess(sptr);
  for a := 0 to botmaxcmd do begin
    if cmd = cmdtab[a].customcmd then begin
      if haslevel(sptr) >= cmdtab[a].level then begin
        if cmdtab[a].minparams > parc then begin
          infolocal := cmdtab[a].info;
          syntaxlocal := cmdtab[a].syntax;
          if assigned(cmdtab[a].extrareplaceproc) then begin
             cmdtab[a].extrareplaceproc(sptr,parc,@parv,s,taccountUSINGbot(tag),infolocal,syntaxlocal);

          end;
          send(sendtalk+replacespecial(syntaxlocal,mybot.name,me.name,cmdtab[a].customcmd,#10+sendtalk));
        end else begin
          if @cmdtab[a].p <> nil then cmdtab[a].p(sptr,parc,@parv,s,taccountUSINGbot(tag),cmdtab[a].info,cmdtab[a].syntax);
        end;
        b := 0;
      end else begin
        b := 1;
      end;
    end;
    if bool then begin {LOGIN must be first entry of cmdtable}
      if ismortal(sptr) then begin
        exit;
      end else begin
        b := 2;
        break;
      end;
    end;
  end;
  if b < 0 then begin

    {handle CTCP requests}
    if cmd[1] = #1 then begin
      if cmd = #1'VERSION'#1 then begin
        sendversionreply;
        exit;
      end else
      if copy(cmd,1,5) = #1'PING' then begin
        send(sendtalk+#1'PING '+parv[1]);
        exit;
      end
    end;
    send(sendtalk+errormsg);
  end else if b = 1 then begin
    send(sendtalk+errormsg);
  end;
 end;
end;

procedure taccountUSINGbot.botinit;
begin
  {fill in some defaults in case they cant be read from config file}

  optiontable_default(optiontable^,maxoptiontable);
  if fileexists(configfile) then begin
    optiontable_load(optiontable^,maxoptiontable,configfile,cfgtag);
  end else begin
    donewconfigchanges;
  end;
  loadcmd;
  buildsorted;
  updatevalidaccounttable;
  //autosavenextts := unixtime+opt.autosave;
end;

procedure onstartup(tag:taddrint);
var
  a,b:integer;
begin
 with taccountUSINGbot(tag) do begin
  //writeln(tag);
  if up then exit;
  up := true;
  botinit;
  taccountUSINGserviceunit(srvunit).accountcore := getaccountcore;
  taccountUSINGserviceunit(srvunit).accountcore.srvunit.onstartup(taccountUSINGserviceunit(srvunit).accountcore.srvunit.tag);

  //currentoperchannel := '';
  b := 0;
  for a := 0 to maxusermodetable do if pos(usermodetable[a].c,aubopt.botmodes) <> 0 then b := b or usermodetable[a].flag;
  mybot := addbot(srvunit,aubopt.nick,aubopt.userid,aubopt.bothost,aubopt.info,b);
  prefix := sendprefixstr(mybot);
  if opt.operchannel <> '' then begin
    bot_join(mybot,opt.operchannel,'+ntsio',mybot.idstr,globaldefaultts);
    //sendparse(mybot.idstr+' '+TOK_MODE+' '+aubopt.operchannel+' +ntsi');
    //currentoperchannel := opt.operchannel;
  end;
  loadaccountdependent;
//  botinit;
  {if we are connected we must iterate through all users logging them in where needed}

  {if isconnected then begin
    currentuser := tuser(globaluserlist);

    while assigned(currentuser) do begin
      if currentuser.account <> '' then onaccount(me,currentuser,srvunit.tag);
      currentuser := tuser(currentuser.next);
    end;

  end;}
  logaction(nil,'startup');
 end;
end;

procedure onshutdown(tag:taddrint);
begin
 with taccountUSINGbot(tag) do begin

  if not up then exit;
  up := false;
  logaction(nil,'shutdown: '+shutdownreason);

  botsave(false);
  localshutdown;

  //cleargline;
  //clearjupe;

  //accountcore.clearaccount;

  bot_quit(mybot,shutdownreason);
  mybot := nil;
  //currentoperchannel := '';
  if taccountUSINGserviceunit(srvunit).accountcore <> globalaccountcore then taccountUSINGserviceunit(srvunit).accountcore.srvunit.onshutdown(taccountUSINGserviceunit(srvunit).accountcore.srvunit.tag);
 end;
end;

procedure ontimer(tag:taddrint);
begin
  with taccountUSINGbot(tag) do begin
    if up then begin
      //debugout('authbot.currentoperchannel='+currentoperchannel);
      //debugout('authbot.locopt.operchannel='+aubopt.operchannel);
      (*debugout('about to autosave');
      if opt.autosave <> 0 then if (unixtime >= autosavenextts) then begin
{        logaction(nil,'autosave');}
        botsave;

      end;
      debugout('autosave complete'); *)
      debugout('about to call locatimehandler');
      debugout(inttostr(tag));
      taccountUSINGbot(tag).localtimehandler;
      debugout('localtimehandler complete');

    end;

  //b_gline.timehandler;
 end;
end;
procedure taccountUSINGbot.localtimehandler;
begin
  {stub}
end;

procedure onsave(tag:taddrint;saveall:boolean);
begin
 with taccountUSINGbot(tag) do begin
  
  botsave(saveall);
 end;
end;


{procedure onrehash(tag:taddrint);
begin
 with taccountUSINGbot(tag) do begin
  if not up then exit;
  logaction(nil,'Received REHASH signal');
  botinit;
 end;
end; }

procedure taccountUSINGbot.setupsrvunit;
begin
  srvunit := taccountUSINGserviceunit.create;
  inherited setupsrvunit;
  srvunit.onstartup := onstartup;
  srvunit.onshutdown := onshutdown;
  srvunit.onprivmsg := onprivmsg;
  srvunit.ontimer := ontimer;
  srvunit.onsave := onsave;
  srvunit.onoperchannelchange := onoperchannelchange;
  //srvunit.onaccount := onaccount;
  //srvunit.ondestroyuser := ondestroyuser;
  //srvunit.onrehash := onrehash;
end;

function taccountUSINGbot.haslevel(us:tuser):integer;
var
  p:taccount;
begin
  result := -1;
  if isoper(us) then result := aubopt.operlevel;
  p := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(us);
  if p <> nil then begin
    if p.level > result then result := p.level;
  end;
  //debugout(inttostr(longint(p)));
  //debugout(inttostr(result));
end;

procedure taccountUSINGbot.savecmd;
var
  t:textfile;
  a:integer;
begin
  if not openforwrite(t,commandsfile) then exit;
  writeln(t,'[Auth.commands]');
  for a := 0 to botmaxcmd do begin
    writeln(t,'name='+cmdtab[a].cmd);
    writeln(t,'customname='+cmdtab[a].customcmd);
    writeln(t,'level='+inttostr(cmdtab[a].level));
    writeln(t,'enabled='+inttostr(ord(cmdtab[a].enabled)));
    writeln(t,'info='+cmdtab[a].info);
    writeln(t,'syntax='+cmdtab[a].syntax);
    writeln(t);
  end;
  closefile(t);
end;

var
  currentloadcmd:integer;

var
  loadcmdaccountUSINGbot : taccountUSINGbot;

procedure loadcmdproc(sv,sn:string);
var
  a:integer;
begin
 with loadcmdaccountUSINGbot do begin
  if sv = 'NAME' then begin
    sn := ircupper(sn);
    currentloadcmd := -1;
    for a := 0 to botmaxcmd do if cmdtab[a].cmd = sn then begin
      currentloadcmd := a;
      exit;
    end;
  end else
  if sv = 'CUSTOMNAME' then begin
    if currentloadcmd <> -1 then begin
      sn := ircupper(sn);
      if validcomname(sn) then cmdtab[currentloadcmd].customcmd := sn;
    end;
  end else
  if sv = 'LEVEL' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].level := strtointdef(sn,maxlevel);
    end;
  end else
  if sv = 'ENABLED' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].enabled := sn = '1';
    end;
  end else if sv = 'INFO' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].info := sn;
    end;
  end else if sv = 'SYNTAX' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].syntax := sn;
    end;
  end;
 end;
end;

procedure taccountUSINGbot.loadcmd;
var
  a:integer;
begin
  loadcmdaccountUSINGbot := self;
  currentloadcmd := -1;
  for a := 0 to botmaxcmd do begin
    cmdtab[a].customcmd := cmdtab[a].cmd;
    cmdtab[a].enabled := true;
  end;
  readcfg(commandsfile,@loadcmdproc);
end;

procedure taccountUSINGbot.logaction(sptr:tuser;s:string);
var
  from:string;
  p:taccount;
begin

  if sptr <> nil then begin
    from := nickuserhost(sptr)+'['+ircipbintostr(sptr.binip)+']';
    p := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr);
    if p <> nil then begin
      from := from + '('+p.name+')';
    end;
    from := from + ' ';
  end else begin
    from := '';
  end;

  if opt.operchannel <> '' then send(prefix+TOK_NOTICE+' '+opt.operchannel+' :'+from+s);
  filelog(botlogfile,from+s);
end;

procedure taccountUSINGbot.botsave;
{var
  t:textfile;}
begin
  //autosavenextts := unixtime+opt.autosave;
  savecmd;
  if not saveall then begin
    if taccountUSINGserviceunit(srvunit).accountcore.up then begin
      taccountUSINGserviceunit(srvunit).accountcore.saveaccount(taccountUSINGserviceunit(srvunit).accountcore.accountsfile);
    end;
  end;
  optiontable_save(optiontable^,maxoptiontable,configfile,cfgtag);
end;

function taccountUSINGbot.validaccountname(const s:string):boolean;
var
  a:integer;
begin
  result := false;
  if (s = '') or (length(s) > aubopt.accountlen) then exit;
  if not validaccounttable[0,ord(s[1])] then exit;
  for a := 2 to length(s) do begin
    if not validaccounttable[1,ord(s[a])] then exit;
  end;
  result := true;
end;

procedure taccountUSINGbot.updatevalidaccounttable;

procedure filltable(num:integer;const s:string);
var
  a,b:integer;
begin
  fillchar(validaccounttable[num],sizeof(validaccounttable[num]),0);
  for a := 1 to length(s) do begin
    case s[a] of
      'A':for b := ord('A') to ord('Z') do validaccounttable[num,b] := true;
      'a':for b := ord('a') to ord('z') do validaccounttable[num,b] := true;
      '0':for b := ord('0') to ord('9') do validaccounttable[num,b] := true;
      else validaccounttable[num,ord(s[a])] := true;
    end;
  end;
end;

var
  a:integer;
  s:string;
begin
  s := opt.accountchars;
  a := pos(' ',s);
  assert(a <> 0,'updatevalidaccounttable: no space in accountchars string','');
  filltable(0,copy(s,1,a-1));
  filltable(1,copy(s,a+1,length(s)));
end;

{centralized error replies}
function taccountUSINGbot.error_nosuchaccount(const name:string):string;
begin
  result := 'No such account: '+name;
end;

function taccountUSINGbot.error_nosuchchannel(const name:string):string;
begin
  result := 'No such channel: '+name;
end;

function taccountUSINGbot.error_nosuchnick(const name:string):string;
begin
  result := 'No such nick: '+name;
end;

function taccountUSINGbot.localloginchecks;
begin
  result := true;
end;

function taccountUSINGbot.getloginname(us:tuser):string;
var
  t:taccount;
begin
  result := '';
  t := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(us);
  if t = nil then exit;
  result := t.name;
end;

function taccountUSINGbot.ismortal(us:tuser):boolean;
begin
  //in this class we always return false descendents may do otherwise
  result := false;
end;

function taccountUSINGbot.denyaccess(us:tuser):boolean;
begin
  //in this class we always return false descendents may do otherwise
  result := false;
end;

procedure taccountUSINGbot.localshutdown;
begin
  {stub}
end;

function taccountUSINGbot.getaccountcore;
begin
  result := globalaccountcore;
end;

procedure taccountUSINGbot.sendversionreply;
begin
  {stub}
end;

procedure taccountUSINGbot.loadaccountdependent;
begin
  {stub}
end;

function taccountUSINGbot.hasvoice(us:tuser;ch:tchannel):integer;
begin
  result := access_override;
end;

function taccountUSINGbot.hasop(us:tuser;ch:tchannel):integer;
begin
  result := access_override;
end;

function taccountUSINGbot.hasmaster(us:tuser;ch:tchannel):integer;
begin
  result := access_override;
end;

function taccountUSINGbot.candeopk:boolean;
begin
  result := false;
end;

procedure taccountUSINGbot.buildsorted;
var
  counter : integer;
  changed : boolean;
  temp    : word;
begin
  if not assigned(cmdsorted) then begin
    getmem(cmdsorted,(botmaxcmd+1)*2);
    for counter := 0 to botmaxcmd do begin
      cmdsorted[counter] := counter;
    end;
  end;
  repeat
    changed := false;
    for counter := 0 to botmaxcmd-1 do begin
      if (cmdtab[cmdsorted[counter]].level > cmdtab[cmdsorted[counter+1]].level) or ((cmdtab[cmdsorted[counter]].level = cmdtab[cmdsorted[counter+1]].level) and (cmdtab[cmdsorted[counter]].customcmd > cmdtab[cmdsorted[counter+1]].customcmd)) then begin
        temp                 := cmdsorted[counter]   ;
        cmdsorted[counter]   := cmdsorted[counter+1] ;
        cmdsorted[counter+1] := temp                 ;
        changed              := true                 ;
      end;
    end;
  until not changed;
end;

function taccountUSINGbot.isregisteredchan(channel:string):boolean;
begin
  result := false;
end;

procedure taccountUSINGbot.donewconfigchanges;
begin
  //stub
end;
end.
