
(*
 *  beware IRC services, bworldchan.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit bworldchan;

interface

uses bworldbot,blinklist,bstuff,bconfig;

type
  tchanmanage=class(tlinklist)
    name:string;
    defaultmodes:string;
    {marked:boolean;}
    sender:string;
    ts:integer;
  end;

var
  chanmanagelist:tlinklist;

procedure savechan(const filename:string;botobject:tbworldbot);
procedure loadchan(const filename:string;botobject:tbworldbot);
procedure clearchan(botobject:tbworldbot);

implementation

uses bparse,bcmds,bconsts,buser,unitwritetxt;

procedure clearchan;
var
  gl,gl2:tchanmanage;
begin
  gl := tchanmanage(chanmanagelist);
  while gl <> nil do begin
    gl2 := tchanmanage(gl.next);
    linklistdel(chanmanagelist,tlinklist(gl));
    sendparse(botobject.mybot.idstr+' '+TOK_PART+' '+gl.name+' :');
    gl.destroy;
    gl := gl2;
  end;
end;

procedure savechan(const filename:string;botobject:tbworldbot);
var
  t:textfile;
  gl:tchanmanage;

procedure writechan;
begin
  writeln(t,'[bworld.channel]');
  writeln(t,'name=',gl.name);
  writeln(t,'sender=',gl.sender);
  writeln(t,'modes=',gl.defaultmodes);
  writeln(t,'ts=',inttostr(gl.ts));
  {op=}
  writeln(t);
end;

begin
  if not openforwrite(t,filename) then exit;
  gl := tchanmanage(chanmanagelist);
  while gl <> nil do begin
    writechan;
    gl := tchanmanage(gl.next);
  end;
  closefile(t);
end;

var
  currentchan:tchanmanage;

procedure loadchanfinish;
begin
  if currentchan <> nil then begin
    if currentchan.name <> '' then begin

      linklistadd(chanmanagelist,tlinklist(currentchan));
      {validglinemask(sn);}

    end else currentchan.destroy;
  end;
end;

procedure loadchanproc(sv,sn:string);
begin
  if sv = '[BWORLD.CHANNEL]' then begin
    loadchanfinish;
    currentchan := tchanmanage.create;
    currentchan.ts := globaldefaultts;
  end;
  if currentchan = nil then exit;
  if sv = 'NAME' then begin
    currentchan.name := sn;
  end;
  if sv = 'SENDER' then begin
    currentchan.sender := sn;
  end;
  if sv = 'MODES' then currentchan.defaultmodes := sn;
  if sv = 'TS' then currentchan.ts := strtointdef(sn,globaldefaultts);
end;

procedure loadchan(const filename:string;botobject:tbworldbot);
var
  gl:tchanmanage;

begin
  clearchan(botobject);
  currentchan := nil;
  if botobject.mybot = nil then exit;
  readcfg(filename,@loadchanproc);
  loadchanfinish;
  currentchan := nil;

  gl := tchanmanage(chanmanagelist);
  while gl <> nil do begin
    bot_join(botobject.mybot,gl.name,'+o',botobject.mybot.idstr ,gl.ts);
    sendparse(botobject.mybot.idstr+' '+TOK_MODE+' '+gl.name+' '+gl.defaultmodes);
    gl := tchanmanage(gl.next);
  end;
end;

begin
  chanmanagelist := nil;
end.
