{lsocket.pas}

{signal code by plugwash}

{use this code for whatever you like in programs under whater licence you like
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
}
unit lsignal;

interface
  uses sysutils,
    {$ifdef VER1_0}
      linux,
    {$else}
      baseunix,unix,
    {$endif}
    classes,lcore;

  type
    tsignalevent=procedure(sender:tobject;signal:integer) of object;
    tlsignal=class(tcomponent)
    public
      onsignal           : tsignalevent      ;
      prevsignal         : tlsignal          ;
      nextsignal         : tlsignal          ;

      constructor create(aowner:tcomponent);override;
      destructor destroy;override;
    end;

  const
    {$ifdef VER1_0}
      blockset : sigset=($FFFFFFFF - (1 shr sigstop) - (1 shr sigkill),0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
    {$else}
      {$ifdef darwin}
        blockset : tsigset=(longint($FFFFFFFF - (1 shr sigstop) - (1 shr sigkill)));
      {$else}
        blockset : tsigset=(longint($FFFFFFFF - (1 shr sigstop) - (1 shr sigkill)),0,0,0);
      {$endif}
    {$endif}
  procedure starthandlesignal(signal:integer);

var
  firstsignal : tlsignal;

implementation
{$include unixstuff.inc}

constructor tlsignal.create;
begin
  inherited create(AOwner);
  nextsignal := firstsignal;
  prevsignal := nil;

  if assigned(nextsignal) then nextsignal.prevsignal := self;
  firstsignal := self;

  //interval := 1000;
  //enabled := true;
  //released := false;
end;

destructor tlsignal.destroy;
begin
  if prevsignal <> nil then begin
    prevsignal.nextsignal := nextsignal;
  end else begin
    firstsignal := nextsignal;
  end;
  if nextsignal <> nil then begin
    nextsignal.prevsignal := prevsignal;
  end;
  inherited destroy;
end;


// cdecl procedures are not name mangled
// so USING something unlikely to cause colliesions in the global namespace
// is a good idea
procedure lsignal_handler( Sig : Integer);cdecl;
var
  currentsignal : tlsignal;
begin
  //writeln('in lsignal_hanler');
  currentsignal := firstsignal;
  while assigned(currentsignal) do begin
    if assigned(currentsignal.onsignal) then currentsignal.onsignal(currentsignal,sig);
    currentsignal := currentsignal.nextsignal;

  end;
  //writeln('left lsignal_hanler');
  if assigned(signalloopback) then begin
    signalloopback.sendstr(' ');
  end;
end;

const
  {$ifdef ver1_0}
    saction : sigactionrec = (handler:(sh:lsignal_handler);sa_mask:$FFFFFFFF - (1 shr sigstop) - (1 shr sigkill);sa_flags:0);
  {$else}
    {$ifdef darwin}
      saction : sigactionrec = (sa_handler:tsigaction(lsignal_handler);sa_mask:(longint($FFFFFFFF - (1 shr sigstop) - (1 shr sigkill)));sa_flags:0);
    {$else}
      {$ifdef freebsd}
        saction : sigactionrec = (sa_handler:tsigaction(lsignal_handler);sa_flags:0;sa_mask:(longint($FFFFFFFF - (1 shr sigstop) - (1 shr sigkill)),0,0,0));
      {$else}
        {$ifdef ver1_9_2}
          saction : sigactionrec = (handler:(sh:lsignal_handler);sa_mask:(longint($FFFFFFFF - (1 shr sigstop) - (1 shr sigkill)),0,0,0);sa_flags:0);
        {$else}
          saction : sigactionrec = (sa_handler:lsignal_handler;sa_mask:(longint($FFFFFFFF - (1 shr sigstop) - (1 shr sigkill)),0,0,0);sa_flags:0);
        {$endif}
      {$endif}
    {$endif}
  {$endif}
procedure starthandlesignal(signal:integer);

begin
  if signal in ([0..31]-[sigkill,sigstop]) then begin
    sigprocmask(SIG_BLOCK,@blockset,nil);
    sigaction(signal,@saction,nil)
  end else begin
    raise exception.create('invalid signal number')
  end;
end;


end.
